//package com.cultural.heritage.controller.wxPayDemo;
//
//
//import com.google.gson.Gson;
//import jakarta.annotation.Resource;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.http.client.methods.CloseableHttpResponse;
//import org.apache.http.client.methods.HttpGet;
//import org.apache.http.client.methods.HttpPost;
//import org.apache.http.entity.StringEntity;
//import org.apache.http.impl.client.CloseableHttpClient;
//import org.apache.http.util.EntityUtils;
//import org.springframework.web.bind.annotation.*;
//
//import java.io.IOException;
//import java.util.HashMap;
//import java.util.Map;
//
//@RestController
//@RequestMapping("/api/wx-pay")
//@Slf4j
//public class WxPayController {
//
//    @Resource
//    private CloseableHttpClient wxPayClient;
//
//    @Resource
//    //无需应答签名
//    private CloseableHttpClient wxPayNoSignClient;
//
//    @Resource
//    private WxPayConfig wxPayConfig;
//
//    /**
//     * Native下单
//     */
//    @PostMapping("/native")
//    public void nativePay() throws Exception {
//
//        log.info("发起支付请求 v3");
//
//        log.info("调用统一下单API");
//
//        //调用统一下单API
//        HttpPost httpPost = new HttpPost(wxPayConfig.getDomain().concat(WxApiType.NATIVE_PAY.getType()));
//
//        // 请求body参数
//        Gson gson = new Gson();
//        HashMap<String, Object> paramsMap = new HashMap<>();
//        paramsMap.put("appid", wxPayConfig.getAppid());// APPID
//        paramsMap.put("mchid", wxPayConfig.getMchId());// 商户id
//        paramsMap.put("description", "魏凯的小商铺"); // 订单描述
//        paramsMap.put("out_trade_no", "123456789987"); // 订单号
//        paramsMap.put("notify_url", wxPayConfig.getNotifyDomain().concat(WxNotifyType.NATIVE_NOTIFY.getType()));// 二维码扫描支付成功后进行回调
//
//        Map<String, Object> amountMap = new HashMap<>();
//        amountMap.put("total", 1); // 金额 以分为单位 这里写1分钱 订单号123456789987对应的金额为1分
//        amountMap.put("currency", "CNY");
//
//        paramsMap.put("amount", amountMap);
//
//        //将参数转换成json字符串
//        String jsonParams = gson.toJson(paramsMap);
//        log.info("请求参数 ===> {}" + jsonParams);
//
//        StringEntity entity = new StringEntity(jsonParams, "utf-8");
//        entity.setContentType("application/json");
//        httpPost.setEntity(entity);
//        httpPost.setHeader("Accept", "application/json");
//
//        //完成签名并执行请求（这个地方就是mchId与商户证书密钥进行校验）
//        try (CloseableHttpResponse response = wxPayClient.execute(httpPost)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());//响应体
//            int statusCode = response.getStatusLine().getStatusCode();//响应状态码
//            if (statusCode == 200) { //处理成功
//                log.info("成功, 返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) { //处理成功，无返回Body
//                log.info("成功");
//            } else {
//                log.info("Native下单失败,响应码 = " + statusCode + ",返回结果 = " + bodyAsString);
//                throw new IOException("request failed");
//            }
//            //响应结果
//            HashMap resultMap = gson.fromJson(bodyAsString, HashMap.class);
//            //二维码
//            String codeUrl = (String) resultMap.get("code_url");
//
//            log.info("二维码为: " + codeUrl);
//
//        }
//    }
//
//    /**
//     * 查询订单
//     */
//    @GetMapping("/query/{orderNo}")
//    public void queryOrder(@PathVariable String orderNo) throws Exception {
//
//        log.info("查询订单");
//
//        log.info("查单接口调用 ===> {}", orderNo);
//
//        // 拼接url
//        String url = String.format(WxApiType.ORDER_QUERY_BY_NO.getType(), orderNo);
//        url = wxPayConfig.getDomain().concat(url).concat("?mchid=").concat(wxPayConfig.getMchId());
//
//        HttpGet httpGet = new HttpGet(url);
//        httpGet.setHeader("Accept", "application/json");
//
//        //完成签名并执行请求
//        try (CloseableHttpResponse response = wxPayClient.execute(httpGet)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());//响应体
//            int statusCode = response.getStatusLine().getStatusCode();//响应状态码
//            if (statusCode == 200) { //处理成功
//                log.info("成功, 返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) { //处理成功，无返回Body
//                log.info("成功");
//            } else {
//                log.info("查单接口调用,响应码 = " + statusCode + ",返回结果 = " + bodyAsString);
//                throw new IOException("request failed");
//            }
//        }
//    }
//
//
//    /**
//     * 用户取消订单
//     */
//    @PostMapping("/cancel/{orderNo}")
//    public void cancel(@PathVariable String orderNo) throws Exception {
//
//        log.info("关单接口的调用，订单号 ===> {}", orderNo);
//
//        //创建远程请求对象
//        String url = String.format(WxApiType.CLOSE_ORDER_BY_NO.getType(), orderNo);
//        url = wxPayConfig.getDomain().concat(url);
//        HttpPost httpPost = new HttpPost(url);
//
//        //组装json请求体
//        Gson gson = new Gson();
//        Map<String, String> paramsMap = new HashMap<>();
//        paramsMap.put("mchid", wxPayConfig.getMchId());
//        String jsonParams = gson.toJson(paramsMap);
//        log.info("请求参数 ===> {}", jsonParams);
//
//        //将请求参数设置到请求对象中
//        StringEntity entity = new StringEntity(jsonParams, "utf-8");
//        entity.setContentType("application/json");
//        httpPost.setEntity(entity);
//        httpPost.setHeader("Accept", "application/json");
//
//        //完成签名并执行请求
//        try (CloseableHttpResponse response = wxPayClient.execute(httpPost)) {
//            int statusCode = response.getStatusLine().getStatusCode();//响应状态码
//            if (statusCode == 200) { //处理成功
//                log.info("成功200");
//            } else if (statusCode == 204) { //处理成功，无返回Body
//                log.info("成功204");
//            } else {
//                log.info("Native下单失败,响应码 = " + statusCode);
//                throw new IOException("request failed");
//            }
//        }
//    }
//
//    /**
//     * 用户申请退款
//     */
//    @PostMapping("/refunds/{orderNo}")
//    public void refunds(@PathVariable String orderNo) throws Exception {
//
//        log.info("申请退款");
//        log.info("调用退款API");
//        //调用统一下单API
//        String url = wxPayConfig.getDomain().concat(WxApiType.DOMESTIC_REFUNDS.getType());
//        HttpPost httpPost = new HttpPost(url);
//
//        // 请求body参数
//        Gson gson = new Gson();
//        Map<String, Object> paramsMap = new HashMap<>();
//        paramsMap.put("out_trade_no", orderNo);//订单编号
//        paramsMap.put("out_refund_no", "123456");//退款单编号 随便填
//        paramsMap.put("reason", "随便填一个");//退款原因
//        paramsMap.put("notify_url", wxPayConfig.getNotifyDomain().concat(WxNotifyType.REFUND_NOTIFY.getType()));//退款成功通知地址
//
//        Map<String, java.io.Serializable> amountMap = new HashMap<String, java.io.Serializable>();
//        amountMap.put("refund", 1);//退款金额 这里的金额应该根据订单id查询出来
//        amountMap.put("total", 1);//原订单金额 这里的金额应该根据订单id查询出来
//        amountMap.put("currency", "CNY");//退款币种
//        paramsMap.put("amount", amountMap);
//
//        //将参数转换成json字符串
//        String jsonParams = gson.toJson(paramsMap);
//        log.info("请求参数 ===> {}" + jsonParams);
//
//        StringEntity entity = new StringEntity(jsonParams, "utf-8");
//        entity.setContentType("application/json");//设置请求报文格式
//        httpPost.setEntity(entity);//将请求报文放入请求对象
//        httpPost.setHeader("Accept", "application/json");//设置响应报文格式
//
//        //完成签名并执行请求，并完成验签
//        try (CloseableHttpResponse response = wxPayClient.execute(httpPost)) {
//            //解析响应结果
//            String bodyAsString = EntityUtils.toString(response.getEntity());
//            int statusCode = response.getStatusLine().getStatusCode();
//            if (statusCode == 200) {
//                log.info("成功, 退款返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) {
//                log.info("成功");
//            } else {
//                throw new RuntimeException("退款异常, 响应码 = " + statusCode + ", 退款返回结果 = " + bodyAsString);
//            }
//        }
//    }
//
//    /**
//     * 查询退款
//     */
//    @GetMapping("/query-refund/{refundNo}")
//    public void queryRefund(@PathVariable String refundNo) throws Exception {
//
//        log.info("查询退款");
//        log.info("查询退款接口调用 ===> {}", refundNo);
//
//        String url = String.format(WxApiType.DOMESTIC_REFUNDS_QUERY.getType(), refundNo);
//        url = wxPayConfig.getDomain().concat(url);
//
//        //创建远程Get 请求对象
//        HttpGet httpGet = new HttpGet(url);
//        httpGet.setHeader("Accept", "application/json");
//
//        //完成签名并执行请求
//        try (CloseableHttpResponse response = wxPayClient.execute(httpGet)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());
//            int statusCode = response.getStatusLine().getStatusCode();
//            if (statusCode == 200) {
//                log.info("成功, 查询退款返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) {
//                log.info("成功");
//            } else {
//                throw new RuntimeException("查询退款异常, 响应码 = " + statusCode + ", 查询退款返回结果 = " + bodyAsString);
//            }
//        }
//    }
//
//    /**
//     * 获取账单url 这个url无法在浏览器打开
//     */
//    @GetMapping("/querybill/{billDate}/{type}")
//    public void queryTradeBill(@PathVariable String billDate, @PathVariable String type) throws Exception {
//
//        log.info("获取账单url");
//
//        log.warn("申请账单接口调用 {}", billDate);
//
//        String url = "";
//        if ("tradebill".equals(type)) {
//            url = WxApiType.TRADE_BILLS.getType();
//        } else if ("fundflowbill".equals(type)) {
//            url = WxApiType.FUND_FLOW_BILLS.getType();
//        } else {
//            throw new RuntimeException("不支持的账单类型");
//        }
//
//        url = wxPayConfig.getDomain().concat(url).concat("?bill_date=").concat(billDate);
//
//        //创建远程Get 请求对象
//        HttpGet httpGet = new HttpGet(url);
//        httpGet.addHeader("Accept", "application/json");
//
//        //使用wxPayClient发送请求得到响应
//        try (CloseableHttpResponse response = wxPayClient.execute(httpGet)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());
//
//            int statusCode = response.getStatusLine().getStatusCode();
//            if (statusCode == 200) {
//                log.info("成功, 申请账单返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) {
//                log.info("成功");
//            } else {
//                throw new RuntimeException("申请账单异常, 响应码 = " + statusCode + ", 申请账单返回结果 = " + bodyAsString);
//            }
//            //获取账单下载地址
//            Gson gson = new Gson();
//            Map<String, String> resultMap = gson.fromJson(bodyAsString, HashMap.class);
//            log.info("账单链接；" + resultMap.get("download_url"));
//        }
//    }
//
//    /**
//     * 下载账单
//     */
//    @GetMapping("/downloadbill/{billDate}/{type}")
//    public void downloadBill(@PathVariable String billDate, @PathVariable String type) throws Exception {
//
//        log.info("下载账单");
//        log.warn("下载账单接口调用 {}, {}", billDate, type);
//
//        //获取账单url地址
//        String downloadUrl = this.queryBill(billDate, type);
//        //创建远程Get 请求对象
//        HttpGet httpGet = new HttpGet(downloadUrl);
//        httpGet.addHeader("Accept", "application/json");
//
//        //使用wxPayClient发送请求得到响应
//        try (CloseableHttpResponse response = wxPayNoSignClient.execute(httpGet)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());
//            int statusCode = response.getStatusLine().getStatusCode();
//            if (statusCode == 200) {
//                log.info("成功, 下载账单返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) {
//                log.info("成功");
//            } else {
//                throw new RuntimeException("下载账单异常, 响应码 = " + statusCode + ", 下载账单返回结果 = " + bodyAsString);
//            }
//        }
//
//    }
//
//    /**
//     * 申请账单
//     */
//    public String queryBill(String billDate, String type) throws Exception {
//        log.warn("申请账单接口调用 {}", billDate);
//
//        String url = "";
//        if ("tradebill".equals(type)) {
//            url = WxApiType.TRADE_BILLS.getType();
//        } else if ("fundflowbill".equals(type)) {
//            url = WxApiType.FUND_FLOW_BILLS.getType();
//        } else {
//            throw new RuntimeException("不支持的账单类型");
//        }
//
//        url = wxPayConfig.getDomain().concat(url).concat("?bill_date=").concat(billDate);
//
//        //创建远程Get 请求对象
//        HttpGet httpGet = new HttpGet(url);
//        httpGet.addHeader("Accept", "application/json");
//
//        //使用wxPayClient发送请求得到响应
//        try (CloseableHttpResponse response = wxPayClient.execute(httpGet)) {
//            String bodyAsString = EntityUtils.toString(response.getEntity());
//
//            int statusCode = response.getStatusLine().getStatusCode();
//            if (statusCode == 200) {
//                log.info("成功, 申请账单返回结果 = " + bodyAsString);
//            } else if (statusCode == 204) {
//                log.info("成功");
//            } else {
//                throw new RuntimeException("申请账单异常, 响应码 = " + statusCode + ", 申请账单返回结果 = " + bodyAsString);
//            }
//
//            //获取账单下载地址
//            Gson gson = new Gson();
//            Map<String, String> resultMap = gson.fromJson(bodyAsString, HashMap.class);
//            return resultMap.get("download_url");
//        }
//    }
//
//}
